/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-01 15:32:38 UTC)
 * on 2013-08-06 at 19:11:42 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.compute.model;

/**
 * A quotas entry.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Compute Engine API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Quota extends com.google.api.client.json.GenericJson {

  /**
   * Quota limit for this metric.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Double limit;

  /**
   * Name of the quota metric.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String metric;

  /**
   * Current usage of this metric.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Double usage;

  /**
   * Quota limit for this metric.
   * @return value or {@code null} for none
   */
  public java.lang.Double getLimit() {
    return limit;
  }

  /**
   * Quota limit for this metric.
   * @param limit limit or {@code null} for none
   */
  public Quota setLimit(java.lang.Double limit) {
    this.limit = limit;
    return this;
  }

  /**
   * Name of the quota metric.
   * @return value or {@code null} for none
   */
  public java.lang.String getMetric() {
    return metric;
  }

  /**
   * Name of the quota metric.
   * @param metric metric or {@code null} for none
   */
  public Quota setMetric(java.lang.String metric) {
    this.metric = metric;
    return this;
  }

  /**
   * Current usage of this metric.
   * @return value or {@code null} for none
   */
  public java.lang.Double getUsage() {
    return usage;
  }

  /**
   * Current usage of this metric.
   * @param usage usage or {@code null} for none
   */
  public Quota setUsage(java.lang.Double usage) {
    this.usage = usage;
    return this;
  }

  @Override
  public Quota set(String fieldName, Object value) {
    return (Quota) super.set(fieldName, value);
  }

  @Override
  public Quota clone() {
    return (Quota) super.clone();
  }

}
